var AntHeartBeat = {
  
    timeout: 12,
    hour: 60*60*1000,

    init: function() {

        var self = AntHeartBeat;
        
        self.previous = parseInt( AntPrefs.getAntBranch().getCharPref('last_heartbeat_ts') );
        
        var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
        var callback = { notify: function (timer) {
                                    AntLib.toLog('FIRED HEARTBEAT TIMER');
                                    self.sendMessage();
                                }
                        };
        
        self.sendMessage();
        timer.initWithCallback(callback, self.timeout*self.hour, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
    },

    needToSend: function(now) {
    
      var self = AntHeartBeat;
      if(self.previous == -1) {
        return true;
      }
      else {
        var delta = now - self.previous;
        return delta >= self.timeout*self.hour;
      }
    },

    sendMessage: function() {
        
        var self = AntHeartBeat;
        var now = new Date();
        
        if( self.needToSend(now.getTime()) ) {
        
            AntRPC.heartBeat();
            //AntLib.toLog("HEART BEAT: message sent at " + now );
            
            self.previous = now.getTime();
            AntPrefs.getAntBranch().setCharPref('last_heartbeat_ts', now.getTime().toString());
        }
    }
}
